using System;
using System.Collections.Generic;
using System.IO;

using Windows.Storage;
using Windows.Storage.Pickers;
using Windows.Storage.Provider;

using WinRT.Interop;

using Microsoft.UI.Xaml;
using Microsoft.UI.Xaml.Controls;

namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public sealed partial class MainPage : Page
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - MainPage()

        /// <summary>
        /// 
        /// </summary>
        public MainPage()
        {
            InitializeComponent();

            this.saveFileButton.Click += saveFileButton_Click;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Save File ư Ŭ óϱ - saveFileButton_Click(sender, e)

        /// <summary>
        /// Save File ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private async void saveFileButton_Click(object sender, RoutedEventArgs e)
        {
            this.outputTextBlock.Text = "";

            FileSavePicker fileSavePicker = new FileSavePicker();

            Window window = WindowHelper.GetWindowForElement(this);

            IntPtr windowHandle = WindowNative.GetWindowHandle(window);

            InitializeWithWindow.Initialize(fileSavePicker, windowHandle);

            fileSavePicker.SuggestedStartLocation = PickerLocationId.DocumentsLibrary;

            fileSavePicker.FileTypeChoices.Add("Plain Text", new List<string>() { ".txt" });

            fileSavePicker.SuggestedFileName = "sample.txt";

            StorageFile storageFile = await fileSavePicker.PickSaveFileAsync();

            if(storageFile != null)
            {
                CachedFileManager.DeferUpdates(storageFile);

                using(Stream stream = await storageFile.OpenStreamForWriteAsync())
                {
                    using(StreamWriter writer = new StreamWriter(stream))
                    {
                        writer.WriteLine("׽Ʈ ڿ Դϴ.");
                    }
                }

                FileUpdateStatus status = await CachedFileManager.CompleteUpdatesAsync(storageFile);

                if (status == FileUpdateStatus.Complete)
                {
                    this.outputTextBlock.Text = "File " + storageFile.Name + " was saved.";
                }
                else if (status == FileUpdateStatus.CompleteAndRenamed)
                {
                    this.outputTextBlock.Text = "File " + storageFile.Name + " was renamed and saved.";
                }
                else
                {
                    this.outputTextBlock.Text = "File " + storageFile.Name + " couldn't be saved.";
                }
            }
            else
            {
                this.outputTextBlock.Text = "Operation cancelled.";
            }
        }

        #endregion
    }
}